/*
# Copyright (C) 2010
#
# This program is free software; you can redistribute it and/or modify it 
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
#
*/


 #include <pspkernel.h>
#include <pspsdk.h>
#include <psputilsforkernel.h>
#include <pspsysmem_kernel.h>






#include <pspkernel.h>
#include <systemctrl.h>
#include <pspinit.h>

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>



#include <pspsdk.h>
#include <psputilsforkernel.h>
#include <pspsysmem_kernel.h>
#include <psploadcore.h>
#include <pspumd.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/unistd.h>



PSP_MODULE_INFO("Pergame", PSP_MODULE_KERNEL, 1, 5);

#define ISOOFFSET	0x0000B108

#define UMDIDADDR	0x880137B0

#define CFG_MAX_ENTRIES		64
#define LOGBUF_MAX_ENTRIES      64
//#define DEFAULT_DEBUG_LEVEL     2
#define DEFAULT_LOGTOFILE       0


typedef struct LogBuffer {
  int level;
  char entry[256];
} LogBuffer;


//static unsigned int logbuffer_count = 0;
//static unsigned int debug_level = DEFAULT_DEBUG_LEVEL;
static unsigned int logtofile = DEFAULT_LOGTOFILE;
//static unsigned int log_buffering = 0;


//static LogBuffer * logbuffer = NULL;
static int sema = -1;
static int cfg_mem_id = -1;

static char * eboot;
static int bootdev, apitype, keyconf;

char lstr[192];
char lpfxstr[256];
char log_name[256];
char conf_name[256];

typedef struct Cfg {
	char modname[64];
	char bootname[64];
	int level;
} Cfg;

typedef struct Loaded {
  char modname[64];
} Loaded;
//////////////////////////////////
static unsigned int cfg_count = 0;
static Cfg * cfg = NULL;
static unsigned int loaded_count = 0;
static Loaded * loaded = NULL;


STMOD_HANDLER previous = NULL;
int OnModuleStart(SceModule2* mod);
//////////////////////////////////
#define peekbyte(addr) (*((unsigned char*)(long)(addr)));
#define isspace(c) ((c) == ' ' || (c) == '\t' || (c) == '\n' || (c) =='\r' )

#define log(...)\
  sprintf( lstr, __VA_ARGS__ );\
  logfunc(lstr);

#define log2(...);

#define flog(...)\
  sprintf( lstr, __VA_ARGS__ );\
  filelog(lstr);


//////////////////////////////////
int filelog( const char * str ) {
  int fd = sceIoOpen( log_name, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_APPEND, 0777 );
  if (fd >= 0) {
    sceIoWrite( fd, str, strlen( str ) );
    sceIoClose( fd );
  }
  return 0;
}


///////////////////////////////
void logfunc( const char * str ) {
  SceKernelThreadInfo thinfo;
  SceUID thid = sceKernelGetThreadId();
  memset(&thinfo, 0, sizeof(thinfo));                
  thinfo.size = sizeof(thinfo);      
  sceKernelReferThreadStatus(thid, &thinfo);
  sprintf( lpfxstr, "Pergame - %s - %s", thinfo.name, str);
  if (logtofile > 0) { filelog(lpfxstr); }
#ifdef FEH
  if(log_buffering > 0) {
    if (logbuffer_count <= LOGBUF_MAX_ENTRIES ) {
      if ( logbuffer_count == LOGBUF_MAX_ENTRIES ) {
        //flog("\nCXMB: Logbuffer truncated, too many entries.\n");
        log_buffering = 0;
      } else {
        strcpy(logbuffer[logbuffer_count].entry, lpfxstr);
        logbuffer[logbuffer_count].level = 1;
        logbuffer_count++;
      }

    } else {
      sceIoWrite(2, lpfxstr, strlen(lpfxstr));
    }
  }
#endif
}

//////////////
int readLine( int fd, char * buf, int max_len )
{
  int i = 0, bytes;
  while( i < max_len && ( bytes = sceIoRead( fd, buf + i, 1 ) ) == 1 ) {
    if ( buf[i] == -1 || buf[i] == '\n' || buf[i] == '\r' ) break;
    buf[i]=tolower(buf[i]);
    i ++;
  }
  buf[i] = 0;
  if ( bytes != 1 && i == 0 ) return -1;
  return i;
}


//////////////////////////////////
char *strstrip(char *s) {
  size_t size;
  char *end;
  size = strlen(s);
  if (!size)
     return s;
  end = s + size - 1;
  while (end >= s && isspace(*end))
     end--;
  *(end + 1) = '\0';
  while (*s && isspace(*s))
     s++;
  return s;
}
//////////////////////////////////
void parse_conf ( void ) {
  int conf_fd = sceIoOpen( conf_name, PSP_O_RDONLY, 0644 );
  if ( conf_fd >= 0 ) {
    int bytes=0;int line; char buf[256];
    for( line = 0; line < CFG_MAX_ENTRIES; line++ ) {
      bytes=readLine(conf_fd, buf, 256);
      if ( (bytes > 5) && (cfg_count <= CFG_MAX_ENTRIES ) ) {
        strcpy(buf,strstrip(buf));
        if (strncmp(buf, "#", 1)) {
          char *modname;char *bootname;
          modname = strtok(buf, " \t\n\r");
          bootname = strtok(0, "#\r\n");
          if(bootname) {
//            if (strncmp(modname, "ms0:",4) == 0) strcpy(modname,modname+4);
            strcpy(bootname,strstrip(bootname));
//            if (strncmp(bootname, "ms0:",4) == 0) strcpy(bootname,bootname+4);
//            if ( (strlen(bootname) == 10) && ( bootname[4] == '-' ) ) strncpy(bootname+4,bootname+5,6);

            log2("Parsed  entry: modname: '%s', bootname: '%s'\n",modname,bootname);
            strncpy(cfg[cfg_count].modname, modname,strlen(modname)); // FIXME
            strncpy(cfg[cfg_count].bootname, bootname,strlen(bootname));
            cfg_count++;
            if ( cfg_count % 32 == 0 ) {
              Cfg * tmp = sceKernelAllocHeapMemory( cfg_mem_id, sizeof( Cfg ) * ( cfg_count + 32 ) );
              memcpy( tmp, cfg, sizeof( Cfg ) * cfg_count );
              sceKernelFreeHeapMemory( cfg_mem_id, cfg );
              cfg = tmp;
            }
          } else {
            if (strncmp(modname,"logging=1",9)==0) {
              logtofile=1;
              log("Logging activated.\n");
            } else {
              log("Syntax error on line %d: ('%s', '%s')\n",line,modname,bootname);
            }
          }
        }
      }
      if ( bytes < 0 ) { 
        break;
      }
    }
  }
} 


///////////////////////////////////
int loadmod(const char *name, int argc, char **argv) {
  int i;
  for ( i = 0; i < loaded_count; i ++ ) {
    //log2("   %d/%d: '%s' cmp '%s'\n",i,loaded_count,name,loaded[i].modname);
    if ( strncmp( name, loaded[i].modname, strlen(loaded[i].modname) ) == 0 ) {
      log("  module %s already loaded (or attempted to).\n",name);
      return -1;
    }
  }

  strncpy(loaded[loaded_count].modname, name,strlen(name));
  loaded_count++;

  SceUID modid;
  int status;
  char args[1024];
  modid = sceKernelLoadModule(name, 0, NULL);
  if(modid >= 0) {
    modid = sceKernelStartModule(modid, (strlen(name) + 1), (void *) args, &status, NULL);
    log("  start module %s: %08x\n", name, modid );     
  } else {
    log("  load module %s - error: %08x\n", name, modid );
  }
  return modid;
}

///////////////////////////////////
int OnModuleStart(SceModule2* mod) {
  log2("ModuleStart: %s\n", mod->modname );
//  if ( strcmp( mod->modname, "sceKernelLibrary" ) == 0 ) { FIXME - bail somehow }
  if ( strcmp( mod->modname, "sceMediaSync" ) == 0 ) {
    sceKernelSignalSema( sema, 1 );
  }
  return previous((!previous)?0:mod);
}


///////////////////////////////////
int getumdinfo( char * buf ) {
  int fdUMD = sceIoOpen("disc0:/UMD_DATA.BIN",PSP_O_RDONLY,0);
  if (fdUMD >= 0) {
    sceIoRead(fdUMD,buf,10);
    buf[10] = 0;
    sceIoClose(fdUMD);
    log("  disc0:/UMD_DATA.BIN - id: %s.\n",buf);
    return 1;
  } else {
    log("  disc0:/UMD_DATA.BIN - cannot open (0x%08X).\n",fdUMD);
    return 0;
  }
}
///////////////////////////////////
int isopath ( char * buf ) {
  SceModule * sysctrl = ( SceModule * )sceKernelFindModuleByName( "SystemControl" );
  if (sysctrl) {
    SceKernelModuleInfo sysctrlmodinfo;
    unsigned int addr, isoaddr, offset;
    sysctrlmodinfo.size=sizeof(SceKernelModuleInfo);
    sceKernelQueryModuleInfo(sysctrl->modid, &sysctrlmodinfo);
    addr=sysctrlmodinfo.text_addr;
    offset=ISOOFFSET;
    isoaddr=addr + offset;
    log2("isopath: Found (0x%08X) %s, text_addr: 0x%08X + offset: 0x%08X = isoaddr: 0x%08X\n",sysctrl->modid, sysctrl->modname, addr, offset, isoaddr);
    int c;char byte;
    strcpy(buf,"_");
    for ( c=0; c < 64 ; c++ ) {
      byte=peekbyte(isoaddr+c);
      if (byte == '\0') {
        buf[c]=byte;
        break;
      } else {
        buf[c]=(char)tolower(byte);
        buf[c+1]='\0';
      }
    }
    log("isopath: Fetched '%s' from 0x%08X, %d bytes.\n",buf,isoaddr,c);
    if (strlen(buf) < 5) return 0;
    return 1;
  }
  return 0;
}


///////////////////////////////////
int readmemchar ( char * buf, unsigned int addr , unsigned int len ) {
  int c;char byte;
  strcpy(buf,"_");
  for ( c=0; c < len ; c++ ) {
    byte=peekbyte(addr+c);
    if (byte == '\0') {
      buf[c]=byte;
      break;
    } else {
      buf[c]=(char)tolower(byte);
      buf[c+1]='\0';
    }
  }
  log("readmem: Fetched '%s' from 0x%08X, %d bytes.\n",buf,addr,c);
  return len;
}


///////////////////////////////////


///////////////////////////////////
int install( void ) {
  log2("install: sctrlHENSetStartModuleHandler...\n");
  previous = sctrlHENSetStartModuleHandler(OnModuleStart);
  return 0;
}

///////////////////////////////////
int loadmods( char * id ) {
  if (strlen(id) < 4) return 0;
  int si;
  for (si = 0; id[si] != '\0'; si++) {
    id[si] = (char)tolower(id[si]);
  }
//  if (strncmp(id, "ms0:",4) == 0) strcpy(id,id+4);

  int i;
  for ( i = 0; i < cfg_count; i ++ ) {
    if (strncmp( id, cfg[i].bootname, strlen(cfg[i].bootname) ) == 0 ) {
      
      log("match: %s <=> %s: %s\n",id,cfg[i].bootname,cfg[i].modname);
      loadmod(cfg[i].modname, 0, NULL);
    } else if ( (bootdev == PSP_BOOT_DISC) && ( strcmp(cfg[i].bootname,"umd") == 0 || strcmp(cfg[i].bootname,"iso") == 0 ) ) {
      log("generic: %s: %s\n",cfg[i].bootname,cfg[i].modname);
      loadmod(cfg[i].modname, 0, NULL);                                      
    }
  }
  return 0;
}

//////////////////////////////
int main_thread ( SceSize args, void *argp ) {
  sema = sceKernelCreateSema( "pergame_wake", 0, 0, 1, NULL );
  sceKernelWaitSemaCB( sema, 1, NULL );
  log("main: Thread wake. %d cfg entries.\n",cfg_count);
  //char b[12];readmem(b,0x88013780+48,11); // works with UMD or ISO
  if (sceKernelBootFrom() == PSP_BOOT_DISC) {
    int isoread=0; int umdread=0;
    char iso[64];
    char umdID[11];
    isoread=isopath(iso);
#ifdef USE_UMD_DATA_BIN
    umdread=getumdinfo(umdID);
#else
    umdread=readmemchar(umdID,UMDIDADDR,11);
#endif
    log("main: bootfrom: %04X, apitype: %04X, keyconf: %04X, initfile: %s, iso: '%s', umdid: '%s'\n", bootdev, apitype, keyconf, eboot,
      (isoread?iso:"-error-"),(umdread?umdID:"-error-"));
    if(isoread) loadmods(iso);
    if(umdread) loadmods(umdID);
    if(!umdread+isoread) loadmods("-FIXME-");
  } else {
    log("main: bootfrom: %04X, apitype: %04X, keyconf: %04X, initfile: '%s'\n",bootdev, apitype, keyconf, eboot);
    loadmods(eboot);
  }
  sceKernelFreeHeapMemory( cfg_mem_id, cfg );
  sceKernelFreeHeapMemory( cfg_mem_id, loaded );
  sceKernelDeleteHeap( cfg_mem_id );
  cfg = NULL;
  loaded = NULL;
  log("main: cleanup done.\n");
  return 0;
}

///////////////////////////////////
int module_start(SceSize args, char *argp) {
  char * cwdp;
  strcpy(conf_name,argp);
  cwdp = strrchr(conf_name, '/');
  *cwdp = '\0';
  strcpy(log_name,conf_name);
  strcat(conf_name,"/pergame.txt");
  strcat(log_name,"/pergame.log");
  sceIoRemove(log_name);
  log("\n==========\nstart. conf: %s, free kmem: %d\n",conf_name,sceKernelPartitionTotalFreeMemSize(PSP_MEMORY_PARTITION_KERNEL));

  cfg_mem_id = sceKernelCreateHeap( PSP_MEMORY_PARTITION_KERNEL, 
      ( sizeof( Cfg ) * ( CFG_MAX_ENTRIES + 1) ) + 
      ( sizeof( Loaded ) * 17 )
    , 1, "cfg_heap");
  cfg = sceKernelAllocHeapMemory( cfg_mem_id, sizeof( Cfg ) * 32 );//CFG_MAX_ENTRIES );
  memset( cfg, 0, sizeof( Cfg ) * 32 );//CFG_MAX_ENTRIES );

  loaded = sceKernelAllocHeapMemory( cfg_mem_id, sizeof( Loaded ) * 16 );
  memset( cfg, 0, sizeof( Loaded ) * 16 );

  parse_conf();

  if (cfg_count <= 0) return 0; // no point

  eboot = sceKernelInitFileName(); 
  bootdev = sceKernelBootFrom(); // PSP_BOOT_FLASH = 0, PSP_BOOT_DISC = 0x20, PSP_BOOT_MS = 0x40
  apitype = sceKernelInitApitype(); // PSP_INIT_KEYCONFIG_VSH = 0x100, PSP_INIT_KEYCONFIG_GAME = 0x200, PSP_INIT_KEYCONFIG_POPS = 0x300
  keyconf = InitForKernel_7233B5BC(); //

  //log("module_start - bootfrom: %04X, apitype: %04X, keyconf: %04X, initfile: %s, iso: %s\n", bootdev, apitype, keyconf, eboot, (isopath(iso)?iso:"-error-"));

  //char b[12];
  //readmemchar(b,0x880137B0,11);//0x880137B0

  install();

  int th = sceKernelCreateThread("multimod", main_thread, 0x18, 128*150, 0, NULL);// 8, 64*1024, 0, NULL);// 47, 0x400, 0x00001001, NULL);
  if( th >= 0 )
    sceKernelStartThread(th, 0, 0);
  return 0;
}
///////////////////////////////////


int module_stop(SceSize args, void *argp) {
  log("Baibai!\n");
  return 0;
}
